#!/usr/bin/perl
#  Copyright 2001-2018 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('Set Student Impacts' => 'Set Student Impacts',
	   'Main' => 'Main',
	   'School' => 'School',
	   'Save Student Impacts' => 'Save Student Impacts',
	   'Student' => 'Student',
	   'Missing Student!' => 'Missing Student!',
	   'Add More Student Impacts' => 'Add More Student Impacts',
	   'Impacts Updated' => 'Impacts Updated',
	   'No'  => 'No',
	   'Please Log In' => 'Please Log In',

	   );


my $self = 'impactSet.pl';
my $maxImpacts = 6;  # Number of entry forms for impacts for this student...

use DBI;
use CGI;
use CGI::Session;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

#eval require "$globdir/global.conf";
#if ( $@ ) {
#    print $lex{Error}. " $@<br>\n";
#    die $lex{Error}. " $@\n";
#}

my $q = new CGI;
my %arr = $q->Vars;


# Open Database
my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print qq{$doctype\n<html><head>\n};
    print qq{<link rel="stylesheet" href="$iepcss" type="text/css"></head><body>\n};
    print qq{[ <a href="$iephome">$lex{Main}</a> ]\n};

    print qq{<form action="login.pl" method="post" style="display:inline;">\n};
    print qq{<input type="hidden" name="userid" value="$userid">\n};
    print qq{<input type="hidden" name="script" value="$self">\n};
    print qq{<input type="submit" value="$lex{'Please Log In'}">\n};
    print qq{</form></body></html>\n};
    exit;
}


my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "where school = $sdb ";


# Print Page Header
my $title = $lex{'Set Student Impacts'};
print qq{$doctype\n<html><head><title>$title</title>}; 
print qq{<link rel="stylesheet" href="$iepcss" type="text/css">\n};
print qq{$chartype\n</head><body>\n};
print qq{[ <a href="$iephome">$lex{Main}</a> ] $firstname $lastname\n};
print qq{<h1>$title</h1>\n};


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    selectImpacts();

} elsif ( $arr{page} == 2) {
    delete $arr{page};
    writeRecord();
} 

    
#----------------
sub showStartPage {  # select the student
#----------------

    # Get students
    my $sth = $dbh->prepare("select lastname, firstname, studnum from special
      $select order by lastname, firstname");
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    my $sth1 = $dbh->prepare("select count(*) from impact_stud where studnum = ?");

    print qq{<h3>Select Student</h3>\n};    
    print qq{<table cellpadding="5" cellspacing="0" border="1">\n};
    print qq{<tr><th>Student</th><th>Impacts</th></tr>\n};

    my $counter = 1;
   
    while ( my ($lastname, $firstname, $studnum) = $sth->fetchrow ) {

	$sth1->execute( $studnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my $count = $sth1->fetchrow;
	
	
	print qq{<tr><td>$counter. \n};
	print qq{<form action="$self" method="post" style="display:inline;">\n};
	print qq{<input type="hidden" name="page" value="1">\n};
	print qq{<input type="hidden" name="studnum" value="$studnum">\n};
	print qq{<input type="submit" value="$firstname $lastname ($studnum)"></form></td>};
	print qq{<td class="cn">$count</td></tr>\n\n};
	$counter++;
    }


    print qq{</table>\n};
    print qq{</body></html>\n};
    exit;

} # end of showStartPage


#----------------
sub selectImpacts {
#----------------
   
    # get the values from configuration system
    my $sth = $dbh->prepare("select id, datavalue from conf_system where dataname = ?");
    foreach my $field ( qw(g_ImpactArea g_Impact g_ImpactValue) ) {
	$sth->execute( $field );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	while ( my ($id, $datavalue) = $sth->fetchrow ) {
	    eval $datavalue;
	    if ( $@ ) {
		print "$lex{Error}: $@<br>\n";
		exit "$lex{Error}: $@\n";
	    }
	}
    }


    # assemble into a 2 dimensional array.
    my %revArea = reverse %g_ImpactArea;
    my %impacts;  # impacts{area}{impact}
    foreach my $impact ( keys %g_Impact ) {
	my $area = $revArea{ $g_Impact{$impact} };
	#    print "Impact:$impact Area:$area<br>\n";
	$impacts{$area}{$impact} = 1;
    }


=head
print "Impacts:<br>";
foreach my $area ( sort keys %impacts ) {
    foreach my $impact ( sort keys %{ $impacts{$area}} ) {
	print qq{Area:$area  Impact:$impact<br>\n};
    }
}

exit;
=cut

    # Load the impact descriptions.
    my %impactDesc;
    my $sth = $dbh->prepare("select * from impact_mst");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    while ( my $ref = $sth->fetchrow_hashref ) {
	my %r = %$ref;
	$impactDesc{$r{impact}}{$r{val}} = $r{description};
	#    print qq{:$r{impact}:<br>\n};
    }


    # view hash structure
    #foreach my $impact ( sort keys %impactDesc ) {
    #    foreach my $val ( sort keys %{ $impactDesc{$impact} } ) {
    #	print "Impact:$impact: Val:$val: Desc:$impactDesc{$impact}{$val}<br>\n";
    #    }
    #}


    # Student Info
    my $sth = $dbh->prepare("select lastname, firstname from special where studnum = ?");
    $sth->execute( $arr{studnum} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname ) = $sth->fetchrow;

    print qq{<h3>$firstname $lastname ($arr{studnum})</h3>\n};


    # Load their current impacts, predefined or other.
    my (%currimpacts, %otherimpacts ); # the impacts they currently have.

    
    my $sth = $dbh->prepare("select * from impact_stud where studnum = ?");
    $sth->execute( $arr{studnum} );
    while ( my $ref = $sth->fetchrow_hashref ) {
	
	my %r = %$ref;

	if ( $r{other} ) { # an 'other' impact
	    $otherimpacts{ $r{other} } = { 'area' => $r{otherarea}, 'val' => $r{val}, 'id' => $r{id} };

	} else { # a predefined impact
	    $currimpacts{ $r{impact} } = $r{val};
	}
	    
	
#	if ( $first ) { # start table
#	    print qq{<table cellpadding="5" cellspacing="0" border="1">\n};
#	    print qq{<caption style="font-weight:bold;font-size:120%;">Current Impacts</caption>\n};
#	    print qq{<tr><th>Impact</th><th>Support Level</th>\n\n};
#	    $first = 0;
#	}

#	print qq{<tr><td>$counter. $r{impact}</td><td>$g_ImpactValue{$r{val}}</td></tr>\n};
	
    }
    
 	
    # Start the form.
    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="2">\n};
    print qq{<input type="hidden" name="studnum" value="$arr{studnum}">\n};

    print qq{<div style="padding:0.3em;"><input type="submit" value="};
    print qq{$lex{'Save Student Impacts'}"></div>\n};


    # Start the Table
    print qq{<table cellpadding="5" cellspacing="0" border="1">\n};
    print qq{<caption>Set Support Level to blank to delete existing impact</caption>\n};
    print qq{<tr><th>Area</th><th>Impact</th><th>Support Level</th></tr>\n};
    print qq{<tr><th></th><th colspan="2">Hover on Impact to see detailed choices</th></tr>\n\n};

    
    # Loop
    my $counter = 1;
    foreach my $area ( sort keys %impacts ) {
	foreach my $impact ( sort keys %{ $impacts{$area}} ) {
#	    if  ( $currimpacts{$impact} ) { next; } # skip this one, since we already have it.

	    print qq{<tr><td class="la">$counter. $area</td>};
	    print qq{<td title="$impact\n};
	    for my $v (1..4) {
		print qq{$v. $impactDesc{$impact}{$v}\n};
	    }
	    print qq{">$impact</td>\n};

	    my $supportval = $g_ImpactValue{ $currimpacts{$impact} };
	    print qq{<td><select name="$impact"><option value="$currimpacts{$impact}">$supportval</option>\n};
	    foreach my $val (1..4 ) {
		print qq{<option value="$val">$g_ImpactValue{$val}</option>\n};
	    }
	    print qq{<option></option></select></td></tr>\n};
	    $counter++;
	}
    } # End of current impacts loop

    print qq{</table>\n\n};


    # The 'other' impacts
    print qq{<table cellpadding="5" cellspacing="0" border="1" style="margin-top:2em;">\n};
    print qq{<tr><th>Non-Predefined Impact</th><th>Area</th><th>Support Level</th></tr>\n};
    

    # Existing 'Other' Impacts
    foreach my $impact ( sort keys %otherimpacts ) {
	my $area = $otherimpacts{$impact}{area};
	my $val = $otherimpacts{$impact}{val};
	my $id = $otherimpacts{$impact}{id};
	print qq{<tr><td><input type="text" name="OTHIMPID:$id" size="60" value="$impact" maxlength="255"></td>\n};
	
	print qq{<td><select name="OTHAREAID:$id"><option>$area</option>\n};
	foreach my $ar ( sort keys %g_ImpactArea ) {
	    print qq{<option>$ar</option>\n};
	}
	print qq{<option></option></select></td>\n};
	
	# Now support level.
	my $supportval = $g_ImpactValue{ $val };
	print qq{<td><select name="OTHVALID:$id"><option value="$val">$supportval</option>\n};
	foreach my $val (1..4 ) {
	    print qq{<option value="$val">$g_ImpactValue{$val}</option>\n};
	}
	print qq{<option></option></select></td></tr>\n};

    }


    # New 'Other' Impacts
    for my $oid ( 1 .. $maxImpacts ) {

	print qq{<tr><td><input type="text" name="OTH:$oid" size="60" maxlength="255"></td>\n};
	
	print qq{<td><select name="OTHAREA:$oid"><option>};
	foreach my $ar ( sort keys %g_ImpactArea ) {
	    print qq{<option>$ar</option>\n};
	}
	print qq{</select></td>\n};

	print qq{<td><select name="OTHVAL:$oid"><option></option>\n};
	foreach my $val (1..4 ) {
	    print qq{<option value="$val">$g_ImpactValue{$val}</option>\n};
	}
	print qq{</select></td></tr>\n\n};
    }

    print qq{</table>\n};

    print qq{<p><input type="submit" value="$lex{'Save Student Impacts'}"></p>};

    print qq{</form></body></html>\n};

    exit;
}



#--------------
sub writeRecord {
#--------------

#    foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
#    exit;
    
    my $studnum = $arr{studnum};
    delete $arr{studnum};

    # Loop through all the new 'others' and put into hash
    my $sth = $dbh->prepare("insert into impact_stud (studnum, other, otherarea, val ) 
       values (?,?,?,?)");

    my %others;
    for my $oid ( 1 .. $maxImpacts ) {
	if ( my $impact = $arr{"OTH:$oid"} ) { # we have a new 'other impact'
	    my $area = $arr{"OTHAREA:$oid"};
	    my $val = $arr{"OTHVAL:$oid"};
	    if ( not $area or not $val ) {
		print qq{<h3>Missing Area or Support Level for: $impact. Skipping!</h3>\n};
	    } else { # add this record.
		$sth->execute( $studnum, $impact, $area, $val );
		if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    }
	}

	delete $arr{"OTH:$oid"};
	delete $arr{"OTHAREA:$oid"};
	delete $arr{"OTHVAL:$oid"};

	
    }
    
#    foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
 
   
    
    # Predefined Impact add.
    my $sth = $dbh->prepare("insert into impact_stud (studnum, impact, val ) 
        values (?,?,?)");

    # Predef Impact Exists
    my $sth1 = $dbh->prepare("select id from impact_stud where studnum = ? and impact = ?");

    # Update OTHER Record
    my $sth2 = $dbh->prepare("update impact_stud set other = ?, otherarea = ?, val = ? where id = ?");

    # Delete Record
    my $sth3 = $dbh->prepare("delete from impact_stud where id = ?");

    # Update Predefined
    my $sth4 = $dbh->prepare("update impact_stud set val = ? where id = ?");
    

    # Loop through looking for other fields to update for existing OTHERS
    foreach my $key ( keys %arr ) {

	my ($type, $id) = split(':', $key);

	if ( $type eq 'OTHIMPID' and $id ) {
	    my $impact = $arr{$key};
	    my $areakey = "OTHAREAID:$id";
	    my $area = $arr{$areakey};
	    my $val = $arr{"OTHVALID:$id"};
#	    print "$impact - $area - $val  ID:$id<br>\n";	    
	    if ( not $area or not $val or not $impact ) {  # delete the record
		$sth3->execute( $id );
		if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
		print qq{<div>Deleted Impact:$impact (ID:$id).</div>\n};
		
	    } else { # update this record.
		$sth2->execute( $impact, $area, $val, $id );
		if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    }

	    delete $arr{"OTHIMPID:$id"};
	    delete $arr{"OTHAREAID:$id"};
	    delete $arr{"OTHVALID:$id"};
	}

    }

    
#    foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    
	
    # Now only the predefined impacts are left in %arr
    foreach my $key ( keys %arr ) {
	if ( $arr{$key} ) { # if we have a value, add it.
	    
	    # Check if it exists; if so, update val
	    $sth1->execute( $studnum, $key );  # key is an impact for this level
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    my $id = $sth1->fetchrow;
	    
	    if ( $id ) { # update
		$sth4->execute( $arr{$key}, $id ); # only val and id
		if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    } else { # add
		$sth->execute($studnum, $key, $arr{$key} );
		if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    }
	} else { # no support val,
	    
	    # Check if it exists; if so, delete
	    $sth1->execute( $studnum, $key );  # key is an impact for this level
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    my $id = $sth1->fetchrow;

	    if ( $id ) {
		$sth3->execute( $id );
		if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
		print qq{<div>Deleted Impact:$key (ID:$id).</div>\n};		
	    }
	}
    }

    
    print qq{<h3>Impacts Updated</h3>\n};

    
    print qq{<p>[ <a href="$iephome">$lex{Main}</a> |\n};
    print qq{<a href="$self">$lex{'Add More Student Impacts'}</a> |\n};

    print qq{</body></html>\n};

    exit;

} # End of writeRecord()
