#!/usr/bin/perl
#  Copyright 2001-2018 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('View/Delete Teams' => 'View/Delete Teams',
	   'School' => 'School',
	   'Person' => 'Person',
	   'Role' => 'Role',
	   'Phone' => 'Phone',
	   'Email' => 'Email',
	   'Sign' => 'Sign',
	   'Delete' => 'Delete',
	   'Main' => 'Main',
	   'Error' => 'Error',
	   'Please Log In' => 'Please Log In',
	   'Delete Team Members' => 'Delete Team Members',
	   'Record Deletion Failed' => 'Record Deletion Failed',
	   'Contact' => 'Contact',
	   'Error' => 'Error',
	   'Record(s) deleted' => 'Record(s) deleted',
	   'Please Log In' => 'Please Log In',

	   );

my $self = 'teamdelete.pl';

use DBI;
use CGI;
use CGI::Session;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print qq{$doctype\n<html><head>\n};
    print qq{<link rel="stylesheet" href="$iepcss" type="text/css"></head><body>\n};
    print qq{[ <a href="$iephome">$lex{Main}</a> ]\n};
    print qq{<form action="login.pl" method="post" style="display:inline;">\n};
    print qq{<input type="hidden" name="userid" value="$userid">\n};
    print qq{<input type="hidden" name="script" value="$self">\n};
    print qq{<input type="submit" value="$lex{'Please Log In'}">\n};
    print qq{</form></center></body></html>\n};
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "and school = $sdb ";

my $sth = $dbh->prepare("select t.id, t.studnum, t.userid, t.jobtitle, 
   t.phone, t.email, t.sign, t.firstname, t.lastname from team as t, special as s 
   where s.studnum = t.studnum $select
   order by s.lastname, s.firstname");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->rows;

my $title = "Delete Team Members";
print qq{$doctype\n<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="$iepcss" type="text/css">\n};
print qq{</head><body>[ <a href="$iephome">$lex{Main}</a> ] $firstname $lastname\n};
print qq{<h1>$title</h1>\n};


if ( $arr{deleteflag} ) {
    delete $arr{deleteflag};
    deleteRecords();
}

# Form Start
print qq{<form action="$self" method="post">\n};
print qq{<input type="hidden" name="deleteflag" value="1">\n};

my $first = 1;

while ( my ( $id, $studnum, $userid, $jobtitle, $phone, $email, $sign, $efirstname, $elastname ) = $sth->fetchrow ) {
  
    $oldstud = $currstud;
    $currstud = $studnum;     

    if ( $oldstud ne $currstud ) {  # We have a new student

	# Lookup Student Name
	$sth1 = $dbh->prepare("select lastname, firstname from special where studnum = ? ");
	$sth1->execute( $studnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my ($lastname, $firstname) = $sth1->fetchrow;
        if ( not $first ) {  # close previous table
	    print qq{</table>};
	} else { $first = 0; }

	print qq{<h3>$firstname $lastname ($currstud)&nbsp;&nbsp;\n};
	print qq{<input type="submit"  value="$lex{'Delete Team Members'}"></h3>\n};
	print qq{<table cellpadding="3" cellspacing="0" border="1">\n};
	print qq{<tr><th>$lex{Person}</th><th>$lex{Role}</th>};
	print qq{<th>$lex{Phone}</th><th>$lex{Email}</th><th>$lex{Sign}</th>};
	print qq{<th>$lex{Delete}</th></tr>\n};
    }
  
    print qq{<tr><td><b>$elastname</b>, $efirstname</td><td><i>$jobtitle</i></td>\n};
    print qq{<td>$phone</td><td><a href="mailto:$email">$email</a></td>\n};
    print qq{<td class="cn">$sign</td>\n};
    print qq{<td class="cn"><input type="checkbox" name="$id" value="1">};
    print qq{</td></tr>\n};
     
} # End of loop counter

print qq{</table>\n};
print qq{<input type="submit"  value="$lex{'Delete Team Members'}">\n};
print qq{</form></body></html>\n};


#----------------
sub deleteRecords {
#----------------

    my $sth = $dbh->prepare("delete from team where id = ?");

    foreach my $key ( keys %arr ) { 

	#print qq{K:$key V:$arr{$key}<br>\n};
	$sth->execute( $key ); # delete the record

	if ( $DBI::errstr ) {
	    print qq{<h1>$lex{'Record Deletion Failed'} $lex{Contact} $adminname<br>\n};
	    print qq{$lex{Error} $DBI::errstr</h1>\n};
	}
    }

    print qq{<h2>$lex{'Record(s) deleted'}</h2>\n};
    print qq{[ <a href="$iephome">$lex{Main}</a> |\n};
    print qq{<a href="teamdelete.pl">$lex{'View/Delete Teams'}</a> ]\n}; 
    print qq{</body></html>\n};

    exit;
}
