#!/usr/bin/perl
#  Copyright 2001-2018 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Insert description about current software updates.

my %lex = ('Main' => 'Main',
	   'Error' => 'Error',
	   'Add' => 'Add',
	   'Continue' => 'Continue',
	   
	   );

use DBI;
use CGI;
use CGI::Session;


my $self = 'updateiep.pl';

my $q = new CGI;
my %arr = $q->Vars;
print $q->header;


my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $day = $tim[3];
if ( length( $month) == 1 ) { $month = '0'. $month; }
if ( length( $day) == 1 ) { $day = '0'. $day; }
my $currdate = "$year-$month-$day";


eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}


#my $dsn = "DBI:$dbtype:dbname=$dbase";
#my $dbh = DBI->connect($dsn,$user,$password);


# Page Header
my $title = "$lex{Add} IEP Update";
print qq{$doctype\n<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="$css" type="text/css">\n};

print qq{$chartype\n</head><body style="padding:1em 2em;">\n};
print qq{[ <a href="$iephome">$lex{Main}</a> ]\n};
print qq{<h1>$title</h1>\n};


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    writeRecord();
}


#----------------
sub showStartPage {
#----------------


    print qq{<form action="$self" method="post"> \n};
    print qq{<input type="hidden" name="page" value="1">\n};
    print qq{<table cellpadding="3" cellspacing="0" border="0">\n};


    print qq{<tr><td class="bra">Title</td>\n};
    print qq{<td class="la"><input type="text" name="title" size="30">\n};
    print qq{</td></tr>\n};

    

    # Update Description
    print qq{<tr><td class="bra">Description</td>\n};
    print qq{<td class="la"><textarea rows="6" cols="100" name="desc"></textarea>\n};
    print qq{</td></tr>\n};


    # Continue to next page
    print qq{<tr><td></td><td><input type="submit" value="$lex{Continue}"></td></tr>\n};

    print qq{</table></form>\n};
    print qq{</body></html>\n};

    exit;

} # end of showStartPage



#---------------
sub writeRecord {
#---------------

    # foreach my $key ( sort keys %arr ) { print qq{K:$key V:$arr{$key}<br>\n}; }
	
    my $dsn = "DBI:$dbtype:dbname=$dbase";
    my $dbh = DBI->connect($dsn,$user,$password);

    my $sth = $dbh->prepare("insert into iepupdate ( description, date, title ) values ( ?, now(), ? )"); 
    $sth->execute( $arr{desc}, $arr{title} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }


    print qq{<h3>IEP Record Stored</h3>\n};

    print qq{<p>[ <a href="$self">$title</a> |\n};
    print qq{<a href="$homepage">$lex{Main}</a> ]</p></body></html>\n};

    exit;

}
