#!/usr/bin/perl
#  Copyright 2001-2010 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Error' => 'Error',

	   );

my $self = 'exportldif.pl';

use DBI;
use CGI;
use Net::LDAP::Entry;
use Net::LDAP::LDIF;

my $ldif = Net::LDAP::LDIF->new( "student.ldif", "w", onerror => 'die' );


# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "../../etc/ldap.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


# my $q = new CGI;
# my %arr = $q->Vars;
# print $q->header( -charset, $charset );

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;


# Find student name, and password
my $sth = $dbh->prepare("select lastname, firstname, studnum, password, 
 ldap_uid, ldap_uidnumber, ldap_gidnumber
 from student order by lastname, firstname"); 
$sth->execute;
if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr; }


while ( my ( $lastname, $firstname, $studnum, $password, $ldap_uid, 
	     $ldap_uidnumber, $ldap_gidnumber ) = $sth->fetchrow ) {
    
    my $entry = Net::LDAP::Entry->new;

    my $encpassword = `/usr/local/sbin/slappasswd -h {md5} -s $password`;
    chomp $encpassword;
    my $newpassword = $encpassword;

    my $uid = $ldap_uid;

    my $group = "ou=$group_student";

    my $dn = 'uid='. "$uid,$group,$basedn";
    my $gidNumber = $ldap_gidnumber;
    my $uidNumber = $ldap_uidnumber;

    $entry->dn($dn);

    $entry->add (
		 ou => $group_student,
		 o => $org,
		 cn => "$firstname $lastname",
		 objectClass => 'person',
		 objectClass => 'organizationalPerson',
		 objectClass => 'inetOrgPerson',
		 objectClass => 'posixAccount',
		 objectClass => 'shadowAccount',
		 objectClass => 'top',
		 sn => $lastname,
		 givenName => $firstname,
		 uid => $uid,
		 uidNumber => $uidNumber,
		 gidNumber => $gidNumber,
		 gecos => "$firstname $lastname",
		 loginShell => '/bin/bash',
		 homeDirectory => "/home/$uid",
		 userPassword => "$newpassword"

		 );

    $uidcount++;

    my $ref = $entry->get_value('userPassword', alloptions => 1 );

#   use Data::Dumper;
#   print Dumper $ref;

    print "$firstname $lastname<br>\n";

    $ldif->write_entry( $entry );

}

$ldif->done();

