#!/usr/bin/perl

my %lex = ('Error' => 'Error',
    );

use Net::LDAP::Entry;
use Net::LDAP::LDIF;

my $ldif = Net::LDAP::LDIF->new( "temp.ldif", "w", onerror => 'die' );

my $basedn = 'dc=jp2,dc=loccsd,dc=ca';

my $entry = Net::LDAP::Entry->new;

$password = 'password';
$firstname = 'Les';
$lastname = 'Richardson';

my $newpassword = `/usr/local/sbin/slappasswd -h {md5} -s $password`;
chomp $newpassword;


my $uid = 'openadmin';
my $group = 'ou=staff';
my $dn = 'uid='. "$uid,$group,$basedn";
my $gidNumber = '50';
my $uidNumber = '1585';

$entry->dn($dn);

$entry->add (
	     ou => 'staff',
	     o => 'jp2.loccsd.ca',
	     cn => "$firstname $lastname",
	     objectClass => 'person',
	     objectClass => 'organizationalPerson',
	     objectClass => 'inetOrgPerson',
	     objectClass => 'posixAccount',
	     objectClass => 'shadowAccount',
	     objectClass => 'top',
	     sn => $lastname,
	     givenName => $firstname,
	     uid => $uid,
	     uidNumber => $uidNumber,
	     gidNumber => $gidNumber,
	     gecos => "$firstname $lastname",
	     loginShell => '/bin/bash',
	     homeDirectory => "/home/$uid",
	     userPassword => "$newpassword"

	     );



$ldif->write_entry( $entry );

$ldif->done();

print "Done!\n";
