#!/usr/bin/perl
#  Copyright 2001-2010 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Error' => 'Error',
	   'Eoy' => 'Eoy',
	   'Synchronize Students' => 'Synchronize Students',
	   'Continue' => 'Continue',
	   'All Students have Accounts' => 'All Students have Accounts',
	   'Add' => 'Add',
	   'Delete' => 'Delete',
	   'Checked' => 'Checked',
	   'Students' => 'Students',
	   'No Password' => 'No Password',

	   );

my $self = 'syncstudent.pl';

# my $slappasswd = '/usr/local/sbin/slappasswd';
# my $basedn = 'dc=jp2,dc=loccsd,dc=ca';
# my $servername = 'myserver.ca'; # address of the LDAP server to manage.

# my $adminuser = 'cn=admin,dc=jp2,dc=loccsd,dc=ca';
# my $adminpassword = 'password';

# my $group_student = 'student';
# my $group_staff = 'staff';
# my $org = 'jp2.loccsd.ca';


use DBI;
use CGI;
use Net::LDAP;
use Net::LDAP::Entry;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval require "../../etc/ldap.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

# Print Page Header
print "$doctype\n<html><head><title>\n";
print $lex{'Synchronize Students'};
print "</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "<style type=\"text\css\">
 td .ra { text-align:right; }
</style>\n";
print "$chartype\n</head><body>[ <a href=\"$homepage\">";
print $lex{Main}. "</a> | <a href=\"$eoypage\">";
print $lex{Eoy}. "</a> ]<center><h1>";

print '<h1>'. $lex{'Synchronize Students'}. "</h1>\n";


# Setup LDAP access
my $ldap = Net::LDAP->new( $servername ) or die "$@\n";
# bind to a directory with dn and password
my $mesg = $ldap->bind( $adminuser, password => $adminpassword );


if ( not $arr{page} ) {
    showStartPage();
} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    selectStudents();
} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    updateLdap();
}



#----------------
sub showStartPage {
#----------------

    # Start the form
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
    print "<table cellpadding=\"3\" border=\"0\" cellspacing=\"0\">\n";

    print "<tr><td><input type=\"radio\" name=\"mode\" value=\"add\" checked=\"checked\">\n";
    print $lex{Add}. "</td><td><input type=\"radio\" name=\"mode\" value=\"delete\">\n";
    print $lex{Delete}. "</td></tr>\n";

    print "<tr><td>". $lex{Checked}. " <input type=\"checkbox\" name=\"chk\" value=\"1\"></td>\n";
    print "<td></td></tr>\n";

    print "<tr><td><input type=\"submit\" value=\"". $lex{Continue}. "\"></td>\n";
    print "<td></td></tr>\n";    

    print "</table></form></body></html>\n";

    exit;

} # end of showStartPage



#-----------------
sub selectStudents {
#-----------------

    my $mode = $arr{mode};
    my $chk;
    if ( $arr{chk} ) { $chk = q{checked="checked"}; }

    print "<div style=\"font-weight:bold;font-size:130%;\">\n";
    if ( $mode eq 'add' ) {
	print $lex{Add};
    } else {
	print $lex{Delete};
    }
    print q{ }. $lex{Students}. "</div>\n";


    # Start the form
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";
    print "<input type=\"hidden\" name=\"mode\" value=\"$mode\">\n";
    print "<table cellpadding=\"3\" border=\"0\" cellspacing=\"0\">\n";

    print "<tr><td class=\"ra\"><input type=\"submit\" value=\"". $lex{Continue}. "\">";
    print "</td><td></td></tr>\n";

    if ( $mode eq 'add' ) {

	# Search LDAP for students uid.
	my $searchbase = "ou=$group_student,$basedn";
	$mesg = $ldap->search( # perform a search
			       base => $searchbase,
			       attrs => ['uid'],
			       filter => "(& (uid=*) )",
			       );

	# check for errors
	$mesg->code && die $mesg->error;

	# Get list of ldap students.
	my %ldapstuds = ();
	foreach my $entry ($mesg->entries) { 
	    my $uid = $entry->get_value( 'uid' );
	    $ldapstuds{$uid} = 1;
	}

	$mesg = $ldap->unbind;   # take down session


	# Compare with local students and find the missing.
	my $first = 1;
	my $sth = $dbh->prepare("select lastname, firstname, studnum, ldap_uid from student
          order by lastname, firstname");
	$sth->execute;
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	while ( my ( $lastname, $firstname, $studnum, $ldapuid ) = $sth->fetchrow ) {
	    if ( not $ldapstuds{ $ldapuid } ) { # missing
		print "<tr><td><b>$lastname</b>, $firstname ($ldapuid)</td>\n<td>";
		print "<input type=\"checkbox\" name=\"$ldapuid\" value=\"1\" ";
		print "$chk ></td></tr>\n";
		$first = 0;
	    }
	}

	if ( $first ) { # nobody found
	    print "<div style=\"font-weight:bold;\">". $lex{'All Students have Accounts'}. "</div>\n";
	    print "</table></form></body></html>\n";
	    exit;
	}



    } else { # mode is delete

	# Show Local Students to Delete
	my $first = 1;
	my $sth = $dbh->prepare("select lastname, firstname, studnum, ldap_uid from student
          order by lastname, firstname");
	$sth->execute;
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	while ( my ( $lastname, $firstname, $studnum, $ldapuid ) = $sth->fetchrow ) {
	    print "<tr><td class=\"ra\">$lastname, $firstname ($ldapuid)</td>\n<td>";
	    print "<input type=\"checkbox\" name=\"$ldapuid\" value=\"1\" ";
	    print "$chk ></td></tr>\n";
	    $first = 0;

	}

    }

    print "<tr><td colspan=\"2\"><input type=\"submit\" value=\"". $lex{Continue}. "\">";
    print "</td></tr></table></form></body></html>\n";
	
    exit;


} # end of selectStudents


#------------------
sub updateLdap {
#------------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $mode = $arr{mode};
    delete $arr{mode};

    # Print Operation Mode
    print "<div style=\"font-weight:bold;font-size:130%;\">\n";
    if ( $mode eq 'add' ) {
	print $lex{Add};
    } else {
	print $lex{Delete};
    }
    print q{ }. $lex{Students}. "</div>\n";
    print "<table cellpadding=\"3\" border=\"0\" cellspacing=\"0\">\n";


    my $sth = $dbh->prepare("select lastname, firstname, ldap_uid, 
       ldap_uidnumber, ldap_gidnumber, password from student where ldap_uid = ?");

    foreach my $userid ( sort keys %arr ) {

	my $entry = Net::LDAP::Entry->new;

	# Get User Information.
	$sth->execute( $userid );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my ( $lastname, $firstname, $ldapuid, $uidnumber, $gidnumber, $password ) 
	    = $sth->fetchrow;
	my $dn = "uid=$ldapuid,ou=$group_student,$basedn";


	$entry->dn($dn);

	if ( $mode eq 'add' ) {

	    if ( not $password ) { print $lex{'No Password'}. ": $firstname $lastname<br>\n"; next; }
	    # Encrypt Password
	    my $newpassword = `$slappasswd -h {md5} -s $password`;
	    chomp $newpassword;

	    # Add the Entry
	    $entry->add(
			ou => 'student',
			o => $org,
			cn => "$firstname $lastname",
			objectClass => 'person',
			objectClass => 'organizationalPerson',
			objectClass => 'inetOrgPerson',
			objectClass => 'posixAccount',
			objectClass => 'shadowAccount',
			objectClass => 'top',
			sn => $lastname,
			givenName => $firstname,
			uid => $ldapuid,
			uidNumber => $uidnumber,
			gidNumber => $gidnumber,
			gecos => "$firstname $lastname",
			loginShell => '/bin/bash',
			homeDirectory => "/home/$ldapuid",
			userPassword => "$newpassword"

			);

	    print '<tr><td><b>'. $lex{Add}. "</b> ";
	    print "$firstname $lastname ($userid)</td></tr>\n";


	} else { # delete mode

	    $entry->delete();

	    print '<tr><td><b>'. $lex{Delete}. "</b> ";
	    print "$firstname $lastname ($userid)</td></tr>\n";

	}

	$entry->update( $ldap ); # update this entry.


    } # end user add loop


    print "</table></body></html>\n";

    exit;

} # end of addLdapStudents
