#!/usr/bin/perl
#  Copyright 2001-2018 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Add' => 'Add',
	   'Clone' => 'Clone',
	   'Subject' => 'Subject',
	   'Section' => 'Section',
	   'Codes' => 'Codes',
	   'Other Codes' => 'Other Codes',
	   'Course Code' => 'Course Code',
	   'Section' => 'Section',
	   'Description' => 'Description',
	   'Short Description' => 'Short Description',
	   'Max' => 'Max',
	   'char' => 'char',
	   'Grade' => 'Grade',
	   'Start Term' => 'Start Term',
	   'End Term' => 'End Term',
	   'Teacher' => 'Teacher',
	   'Sequence' => 'Sequence',
	   'Controls printing order on report card' => 
	     'Controls printing order on report card',
	   'Web Visible' => 'Web Visible',
	   'Y' => 'Y',
	   'N' => 'N',
	   'Instructional Mode' => 'Instructional Mode',
	   'Class' => 'Class',
	   'Distance' => 'Distance',
	   'Exam Mix' => 'Exam Mix',
	   'School' => 'School',
	   'Blended' => 'Blended',
	   'Faculty' => 'Faculty',
	   'Location' => 'Location',
	   'Mark Scheme' => 'Mark Scheme',
	   'Objective' => 'Objective',
	   'Save' => 'Save',
	   'Credit' => 'Credit',
	   'Difficulty' => 'Difficulty',
	   'Subject Area' => 'Subject Area',
	   'Calc Average' => 'Calc Average',
	   'If your subject only has marks and comments, no objective entry' => 
	     'If your subject only has marks and comments, no objective entry',
	   'is required. If you have non-mark based objectives, please enter' =>
	     'is required. If you have non-mark based objectives, please enter',
	   'the description that will appear on the report card. These will' =>
	     'the description that will appear on the report card. These will',
	   'also appear for evaluation entry. Limit: 255 characters' =>
	     'also appear for evaluation entry. Limit: 255 characters',
	   'Error' => 'Error',
	   'Contact' => 'Contact',
	   'No Student(s) Found' => 'No Student(s) Found',
	   'Exists' => 'Exists',
	   'Record(s) Stored' => 'Record(s) Stored',
	   'cannot be larger than' => 'cannot be larger than',
	   'Terms' => 'Terms',
	   'No Spaces' => 'No Spaces',
	   'Only' => 'Only',
	   'Courses' => 'Courses',
	   'Letters' => 'Letters',
	   'Numbers' => 'Numbers',

	   'Continue' => 'Continue',
	   'Master' => 'Master',
	   

	   );

my $studentCheck = 0; # check for students in that grade.
my $defaultSection = '1'; # default section value
my $maxterms = 12; # maximum size of term values.

use DBI;
use CGI;

my $self = 'courseadd.pl';

my $defaultsequence = 100; 
# Starting value for sequence number.

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

# Not needed now.
#eval require "../../etc/transcript.conf";
#if ( $@ ) {
#    print $lex{Error}. " $self: $@<br>\n";
#    die $lex{Error}. "$self: $@\n";
#}


my $title = qq{$lex{Add} $lex{Course} $lex{Master}};
print qq{$doctype\n<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="$css" type="text/css">\n};
print qq{$chartype\n</head><body style="padding:1em 2em;">\n};

print qq{[ <a href="$homepage">$lex{Main}</a> |\n};
print qq{<a href="$reppage">$lex{'Report Card'}</a> ]\n};


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

print qq{<h1>$title</h1>\n};


if ( not $arr{page} ) {
    getGrade();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    selectCourses();

} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    addCourses();

} elsif ( $arr{page} == 3 ) {
    delete $arr{page};
    addObjectives();
    
} elsif ( $arr{page} == 4 ) {
    delete $arr{page};
    writeRecords();
}


#-----------
sub getGrade {  # get the grade for entry.
#-----------

    print qq{<h3>Select Grade</h3>\n};

    my @grades;
    $sth = $dbh->prepare("select distinct grade from student");
    $sth->execute;
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    while ( my $grade = $sth->fetchrow ) {
	push @grades, $grade;
    }

    @grades = sort {$a <=> $b} @grades;

      
    print qq{<table cellpadding="3" cellspacing="0" border="0">\n};
    print qq{<tr><th>Select Grade</th></tr>\n};

    foreach my $grade ( @grades ) {
	print qq{<tr><td>};
	print qq{<form action="$self" method="post">\n};
	print qq{<input type="hidden" name="page" value="1">\n};
	print qq{<input type="hidden" name="grade" value="$grade">\n};
	print qq{<input type="submit" value="$lex{Grade} $grade">\n};
	print qq{</form></td></tr>\n};
    }
    
    print qq{</table>\n};
    print qq{</body></html>\n};

    exit;
}


#----------------
sub selectCourses {
#----------------

    # print qq{<div>Select Course</div>\n};
    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    
    print qq{<h3>Select Grade $arr{grade} Courses</h3>\n};
    
    # Start the form
    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="2">\n};
    print qq{<input type="hidden" name="grade" value="$arr{grade}">\n};

    print qq{<div style="font-weight:bold;font-size:120%;">};
    print qq{Maxiumum Number of Objectives (1-20) <input type="text" size="4" name="maxobj"></div>\n};


    # Start the table.
    print qq{<table cellpadding="3" cellspacing="0" border="1">\n};
    print qq{<tr><td colspan="4"><input type="submit" value="$lex{Continue}"></td></tr>\n};
    print qq{<tr><th>Course</th><th>Code</th><th>Start Date</th><th>End Date</th></tr>\n};

    
    # Load the active courses for this grade;
    $sth = $dbh->prepare("select * from sasked_courses where grade = ? and enddate is NULL order by title");
    $sth->execute( $arr{grade} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    
    while ( my $ref = $sth->fetchrow_hashref ) {
	my %r = %$ref;
	print qq{<tr><td><input type="checkbox" name="$r{code}" value="1"> $r{title}</td><td>$r{code}</td>\n};
	print qq{<td>$r{startdate}</td><td>$r{enddate}</td></tr>\n};

    }

    print qq{<tr><td colspan="4"><input type="submit" value="$lex{Continue}"></td></tr>\n};
    
    print qq{</table></form>\n};
    print qq{</body></html>\n};

    exit;

}
    

#--------------
sub addCourses {
#--------------

    # print qq{<div>Add Course</div>\n};
    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $grade = $arr{grade};
    delete $arr{grade};

   
    if ( $arr{maxobj} > 20 or $arr{maxobj} < 1 ) {
	print qq{<h3>Error in Maximum Number of objectives</h3>\n};
	print qq{</body></html>\n};
	exit;
    }

    my $maxobj = $arr{maxobj};
    delete $arr{maxobj};

    
    # Find the number of terms;
    my $track = $g_MTrackTermType{$grade};
    my $maxterm = scalar keys %{ $g_MTrackTerm{$track}};

    
    # Load teachers into hash
    my (%teachers, %teachername);
    $sth = $dbh->prepare("select lastname, firstname, userid from staff order by lastname, firstname"); 
    $sth->execute;
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    while ( my ( $lastname, $firstname, $userid) = $sth->fetchrow ) {
	$teachers{"$lastname, $firstname ($userid)"} = $userid;
	$teachername{$userid} = "$lastname, $firstname ($userid)";
    }


    # Display Current Courses.
    print qq{<h3>Current Courses</h3>\n};
    $sth = $dbh->prepare("select * from subject where grade = ? order by sequence,description");
    $sth->execute( $grade );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $first = 1;
    while ( my $ref = $sth->fetchrow_hashref ) {
	my %r = %$ref;

	if ( $first ) {
	    print qq{<table cellpadding="3" cellspacing="0" border="0" style="border:1px solid gray;">\n};
	    print qq{<tr><th>Description</th><th>Teacher</th><th>Terms</th><th>Sequence</th></tr>\n};
	    $first = 0;
	}

	print qq{<tr><td>$r{description}</td><td>$r{teacher}</td>};
	print qq{<td>$r{startrptperiod} - $r{endrptperiod}</td><td>$r{sequence}</td></tr>\n};

    }

    if ( not $first ) {
	print qq{</table>\n};
    } else {
	print qq{<h3>No Current Courses</h3>\h3};
    }

    print qq{<h3>New Courses to Add</h3>\n};

    
    
    # Start Form
    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="3">\n};
    print qq{<input type="hidden" name="maxobj" value="$maxobj">\n};
    print qq{<input type="hidden" name="grade" value="$grade">\n};
    
    # Start Table
    print qq{<table cellpadding="3" cellspacing="0" border="0">\n};
    print qq{<tr><td colspan="10" class="la"><input type="submit" value="$lex{Continue}">};
    print qq{ <span style="color:red;padding:1em;font-weight:bold;">All Fields are Required, };
    print qq{Hover on title for description</span></td></tr>\n};

    # Table Titles
    print qq{<tr><th title="Title of the course from Sask Ed">Title</th>};
    print qq{<th title="The standard course code value from Sask Ed">Code</th>};
    print qq{<th title="The unique number (1,2,3) that identifies the particular group of students and a teacher };
    print qq{for this course. Limited to 6 characters, no spaces">Section</th>};

    print qq{<th title="The term in which the course starts.">Start<br>Term</th>};
    print qq{<th title="The term in which the course ends">End<br>Term</th>\n};
    print qq{<th title="The teacher of this section of this course">Teacher</th>};
    
    print qq{<th title="Controls printing order on Report Card">Sequence</th>};
    print qq{<th title="This course gradebook will be visible on parent site">Gradebook<br>Visible</th>};
    
    print qq{<th title="Normally has a 'school' value, except for grade 12 Deptmental exams which are 'blended'">};
    print qq{Exam Mix</th></tr>\n};
#    print qq{<th></th><th></th><th></th>


    my $sth1 = $dbh->prepare("select title from sasked_courses where code = ?");
  
    
    # Table Loop for courses.
    foreach my $code ( keys %arr ) {
	
	# get title
	$sth1->execute( $code );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my $title = $sth1->fetchrow;

	print qq{<tr><td>$title</td><td>$code};
	print qq{<input type="hidden" name="$code:description" value="$title"></td>\n};
	
	# Section
	print qq{<td><input type="text" style="width:40px;" name="$code:section" maxlength="6" value="1"></td>};

	# Start Term
	print qq{<td><select name="$code:startrptperiod"><option></option>};
	for my $trm ( 1..$maxterm ) { print qq{<option>$trm</option>}; }
	print qq{</select></td>\n};
				     
	# End Term
	print qq{<td><select name="$code:endrptperiod"><option></option>};
	for my $trm ( 1..$maxterm ) { print qq{<option>$trm</option>}; }
	print qq{</select></td>\n};
	
	# Teacher
	print qq{<td><select name="$code:teacher"><option></option>};
	for my $key ( sort keys %teachers ) {
	    my $userid = $teachers{$key};
	    my $name = $teachername{$userid};
	    print qq{<option value="$userid">$name</option>};
	}
	print qq{</select></td>\n};

	# Sequence
	print qq{<td><input type="text" size="4" name="$code:sequence"></td>};

	# Gradebook Visible (ie. web visible)
	print qq{<td><select name="$code:visible"><option value="N">No</option>\n};
	print qq{<option value="Y">Yes</option></select></td>\n};

	# Exam Mix (Mark Mix)
	print qq{<td><select name="$code:exammix"><option></option>};
	print qq{<option>School</option><option>Blended</option>\n};
	print qq{</select></td>};

	print qq{</tr>\n\n};

    }

    print qq{</table>\n};

    print qq{<input type="submit" value="$lex{Continue}">\n};
    print qq{</form></body></html>\n};

}


#----------------
sub addObjectives {
#----------------
    
    # print qq{<div>Add Objectives</div>\n};
    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $maxobj = $arr{maxobj};
    delete $arr{maxobj}; # maximum number of objectives needed.


    # Check for any missing values
    my $missingflag;
    foreach my $key ( sort keys %arr ) {
	if ( not $arr{$key} ) {
	    my ($code, $field) = split(':', $key);
	    print qq{<div>Missing Value in course $code for field $field</div>\n};
	    $missingflag = 1;
	}
    }
    if ( $missingflag ) {
	print qq{</body></html>\n};
	exit;
    }

    # Find the code and course names (description)
    my %coursename;
    foreach my $key ( keys %arr ) {
	my ($code, $temp) = split(':', $key );
	if ( $temp eq 'description' ) {
	    $coursename{$code} = $arr{$key};
	}
    }
   
    print qq{<table cellpadding="3" cellspacing="0" border="0" style="border:1px solid gray;">\n};
    print qq{<tr><td>};
    print qq{$lex{'If your subject only has marks and comments, no objective entry'}<br>\n};
    print qq{$lex{'is required. If you have non-mark based objectives, please enter'}<br>\n};
    print qq{$lex{'the description that will appear on the report card. These will'}<br>\n};
    print qq{$lex{'also appear for evaluation entry. Limit: 255 characters'}</td></tr>\n};
    print qq{</table>\n};
    
    # Start Form
    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="4">\n};
    foreach my $key (keys %arr ) {
	print qq{<input type="hidden" name="$key" value="$arr{$key}">\n};
    }
    

    print qq{<input type="submit" value="$lex{Save} $lex{Courses}">\n};
    
    foreach my $code ( keys %coursename ) {
	my $description = $coursename{$code};

	print qq{<h3>$description ($code)</h3>\n};
    
	# Start Table
	print qq{<table cellpadding="3" cellspacing="0" border="0">\n};
	print qq{<tr><th></th><th>Objective</th></tr>\n};
	foreach my $obj ( 1..$maxobj ) {
	    print qq{<tr><td>$obj.</td><td><input type="text" name="$code:q$obj" };
	    print qq{style="width:50em;" maxlength="255"></td></tr>\n};
	}
	print qq{</table>\n};
    }

    print qq{<input type="submit" value="$lex{Save} $lex{Courses}">\n};
    
    print qq{</form>\n};
    print qq{</body></html>\n};

    exit;

}



#---------------
sub writeRecords {
#---------------


    # print qq{<div>Write Records</div>\n};
    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $grade = $arr{grade};
    delete $arr{grade};
    

    # push all data into %data.
    my %data;
    foreach my $key ( sort keys %arr ) {
	$arr{$key} =~ s/^\s+//g; # strip leading and trailing spaces in values.
	$arr{$key} =~ s/\s+$//g;
	my ($code, $field) = split(':', $key);
	$data{$code}{$field} = $arr{$key};
    }


    foreach my $code ( sort keys %data ) {
	my %r = %{ $data{$code}};
	$r{grade} = $grade;
	$r{subjcode} = $code;

	# Check objectives, remove any blank values
	foreach my $val (1..20) {
	    my $field = 'q'. $val;
	    if ( not exists $r{$field} ) { # doesn't exist, skip
		next;
	    }
	    if ( not $r{$field} ) { # no value, delete
		delete $r{$field};
	    }
	}

	
	# Blank Values Check
	my @missing;
	foreach my $field ( sort keys %r ) {
	    if ( not $r{$field} ) {
		push @missing, $field;
	    }
	}
	if ( @missing ) {
	    my $fields = join(',', @missing);
	    print qq{<h3>Missing Fields for $code: $fields. Skipping!</h3>\n};
	    next;
	}

	
	# Section Stripping (spaces, non alphanumerics)
	$r{section} =~ s/\s//g; # strip any spaces in the section value.
	$r{section} =~ s/\W//g; # strip any non-alphanumerics.
	
	# Join Subject and Section to make Subjsec
	my $subjsec = $r{subjsec} = $code. '-'. $r{section};


	# Check for existing subject-section ( subjsec )
	my $sth = $dbh->prepare("select count(*) from subject where subjsec = ?");
	$sth->execute( $subjsec );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	my $count = $sth->fetchrow;
	if ( $count > 0 ){
	    print qq{<h3>$lex{Course} $lex{Exists} - $subjsec. Skipping!</h3>\n};
	    next;
	}

	
	# Check for start/end term errors: sequence, < 1, > maxterms
	print qq{Start Term:$r{startrptperiod} End Term: $r{endrptperiod}<br>\n};
	
	if ( $r{startrptperiod} > $r{endrptperiod} or 
	     $r{startrptperiod} < 1 or $r{endrptperiod} < 1 ) {
	    print qq{<h3>$code: $lex{'Start Term'} $lex{'cannot be larger than'} $lex{'End Term'} Skipping</h3>\n};
	    next;
	}

	if ( $r{startrptperiod} > $maxterms or $r{endrptperiod} > $maxterms ) {
	    print qq{<h3>$code: $lex{Terms} $lex{'cannot be larger than'} $maxterms. Skipping</h3>\n};
	    next;
	}


	$sth = $dbh->prepare("insert into subject ( subjcode, description, grade, teacher,
         sequence , section, subjsec,
         q1, q2, q3, q4, q5, q6, q7, q8, q9, q10,
         q11, q12, q13, q14, q15, q16, q17, q18, q19, q20,
         visible, startrptperiod, endrptperiod, location, exammix )
         values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,
                ?,?,?,?,?,?,?,?,?,?,?,?)");
	# 33 fields;

	$sth->execute( $r{subjcode}, $r{description}, $r{grade}, $r{teacher}, $r{sequence}, $r{section}, $subjsec,
		       $r{q1}, $r{q2}, $r{q3}, $r{q4}, $r{q5}, $r{q6}, $r{q7}, $r{q8}, $r{q9}, $r{q10},
		       $r{q11}, $r{q12}, $r{q13}, $r{q14}, $r{q15}, $r{q16}, $r{q17}, $r{q18}, $r{q19}, $r{q20},
		       $r{visible}, $r{startrptperiod}, $r{endrptperiod}, $r{location}, $r{exammix} );

    } # next code (course)

	
    if (not $DBI::errstr ) {
	print qq{<h3>$lex{'Record(s) Stored'}</h3>\n};
    } else { 
	print qq{<h3>$lex{Error}: $DBI::errstr</h3>};
    }

    print qq{<p>[ <a href="$self">$lex{Add} $lex{Course}</a> |\n};
    print qq{<a href="$reppage">$lex{'Report Card'}</a> ]</p>\n};
    print qq{</body></html>\n};

    exit;

}
