#! /usr/bin/perl
#  Copyright 2001-2013 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'No Student(s) Found' => 'No Student(s) Found',
	   'Parent' => 'Parent',
	   'Access Control' => 'Access Control',
	   'Continue' => 'Continue',
	   'Homeroom' => 'Homeroom',
	   'Grade' => 'Grade',
	   'Blank=All' => 'Blank=All',
	   'Students' => 'Students',
	   'Select by' => 'Select by',
	   'Not Found' => 'Not Found',
	   'Error' => 'Error',
	   'Single Value Only' => 'Single Value Only',
	   'Check' => 'Check',
	   'Next Page' => 'Next Page',
	   'Report Card' => 'Report Card',
	   'Gradebook' => 'Gradebook',
	   'Disable' => 'Disable',
	   'Student' => 'Student',
	   'Lockout' => 'Lockout',
	   'Save' => 'Save',
	   'Records' => 'Records',
	   'Updated' => 'Updated',

	   );

my $self = 'setlockout.pl';

use DBI;
use CGI;


eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

my $title = "$lex{Parent} $lex{'Access Control'}";
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body style=\"padding:1em 5em;\">\n";
print "<div>[ <a href=\"$homepage\">$lex{Main}</a> ]</div>\n";

print "<h1>$title</h1>\n";

if ( not $arr{page} ) {
    showStartPage();
} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    showStudents();

}  elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    setLockout();
}


#---------------
sub showStudents {
#---------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my ($select, $group, $sth );
    my @students = ();
    my %students = ();


    if ( $arr{groupvalue} ) { # check against existing, otherwise do all students

	if ( $arr{group} eq 'grade' ) {
	    # Check Grades
	    $sth = $dbh->prepare("select distinct grade from student where 
              grade != 0 and grade is not NULL and grade != '' ");
	    $sth->execute;
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    my $first = 1;
	    my $grade;
	    while ( my $gr = $sth->fetchrow ) {
		if ( $gr eq $arr{groupvalue} ) { $first = 0; $grade = $gr; last; }
	    }

	    if ( $first ) {
		print "<h3>$lex{Grade} $lex{'Not Found'}</h3>\n";
		print "</body></html>\n";
		exit;
	    }
	    # if here, we found the grade;
	    $select = qq{where grade = '$grade'};

	    $sth = $dbh->prepare("select lastname, firstname, studnum, parent_lockout from student 
             $select order by lastname, firstname");
	    $sth->execute;
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    while ( my ($lastname, $firstname, $studnum, $lockout ) = $sth->fetchrow ) { 
		push @students, $studnum;
		$students{$studnum} = { lastname => $lastname, firstname => $firstname, lockout => $lockout };
	    }


	} else { # homeroom
	    # Check Homerooms
	    $sth = $dbh->prepare("select distinct homeroom from student where 
              homeroom != 0 and homeroom is not NULL and homeroom != '' ");
	    $sth->execute;
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    my $first = 1;
	    my $homeroom;
	    while ( my $hr = $sth->fetchrow ) {
		if ( $hr eq $arr{groupvalue} ) { $first = 0; $homeroom = $hr; last; }
	    }

	    if ( $first ) {
		print "<h3>$lex{Homeroom} $lex{'Not Found'}</h3>\n";
		print "</body></html>\n";
		exit;
	    }
	    # if here, we found the grade;
	    $select = qq{where homeroom = '$homeroom'};

	    $sth = $dbh->prepare("select lastname, firstname, studnum, parent_lockout from student 
             $select order by lastname, firstname");
	    $sth->execute;
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    while ( my ($lastname, $firstname, $studnum, $lockout ) = $sth->fetchrow ) { 
		push @students, $studnum;
		$students{$studnum} = { lastname => $lastname, firstname => $firstname, lockout => $lockout };
	    }


	}

    } else { # all students

	$sth = $dbh->prepare("select lastname, firstname, studnum, parent_lockout from student 
          order by lastname, firstname");
	$sth->execute;
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	while ( my ($lastname, $firstname, $studnum, $lockout ) = $sth->fetchrow ) { 
	    push @students, $studnum;
	    $students{$studnum} = { lastname => $lastname, firstname => $firstname, lockout => $lockout };
	}
    }


    # Start Form
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";
    

    # Now Display Choices
    print qq{<table cellspacing="0" cellpadding="3" border="1">\n};
    print "<tr><th>$lex{Student}</th><th>$lex{'Report Card'}<br>$lex{Lockout}</th>";
    print "<th>$lex{Gradebook}<br>$lex{Lockout}</th></tr>\n";
	
    foreach my $studnum ( @students ) {
	my @vals = split(//, $students{$studnum}{lockout} );
	my ( $rcheck, $gcheck );
	foreach my $val ( @vals ) {
	    if ( $val eq 'R' ) { $rcheck = 'checked="checked"';}
	    if ( $val eq 'G' ) { $gcheck = 'checked="checked"';}
	}

	print qq{<tr><td class="la"><b>$students{$studnum}{lastname}</b>, $students{$studnum}{firstname} ($studnum)</td>\n};
	if ( $rcheck ) { print qq{<input type="hidden" name="R:$studnum" value="0">\n}; };
	if ( $gcheck ) { print qq{<input type="hidden" name="G:$studnum" value="0">\n}; };
	print qq{<td class="cn"><input type="checkbox" name="R:$studnum" value="1" $rcheck></td>\n};
	print qq{<td class="cn"><input type="checkbox" name="G:$studnum" value="1" $gcheck></td>\n\n};

    }

    print qq{<tr><td class="cn" colspan="3"><input type="submit" value="$lex{Save}"></td></tr>\n};


    print "</table></form>\n";
    print "</body></html>\n";

    exit;

}


#-------------
sub setLockout {
#-------------

    foreach my $key ( sort keys %arr ) { 
	# print "K:$key V:$arr{$key}<br>\n";
	if ( $arr{$key} =~ m/\0/ ) { $arr{$key} = 1; }
	    #my @vals = split(/\0/, $arr{$key} );
	    #foreach my $val ( @vals ) { print "VAL:$val<br>\n"; }
	
    }

#    foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; } 


    # Prepare to Update
    my $sth = $dbh->prepare("update student set  parent_lockout = ? where studnum = ?"); 
    my %students = ();

    # put in student hash
    foreach my $key ( keys %arr ) {
	my ( $type, $studnum ) = split(/:/, $key);
	$students{$studnum}{$type} = $arr{$key}; # could be zero or one value
    }


    foreach my $studnum ( keys %students ) {
	my %locks = %{ $students{$studnum} };
	foreach my $key ( keys %locks ) { 
	    if ( not $locks{$key} ) { delete $locks{$key}; }
	} 

	my $string = join('', sort keys %locks );
	# print "$studnum - $string<br>\n";

	$sth->execute( $string, $studnum );
	if ($DBI::errstr) { print $DBI::errstr; }
    }

    if ( $DBI::errstr ) {
	print "<h3>$lex{Error}: $DBI::errstr</h3>\n";
    } else {
	print "<h3>$lex{Records} $lex{Updated}</h3>\n";
    }

    print "</body></html>\n";

    exit;

} # end of setLockout;




#----------------
sub showStartPage { # Entry Values for Custom Script
#----------------

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

#    print "<tr><td></td><td><input type=\"submit\" value=\"$lex{Continue}\"></td></tr>\n";

    # Student Group
    print "<tr><td class=\"ra\">$lex{'Select by'}</td>";
    print "<td><select name=\"group\"><option value=\"grade\">$lex{Grade}</option>";
    print "<option value=\"homeroom\">$lex{Homeroom}</option></select>\n";
    print " <input type=\"text\" name=\"groupvalue\" size=\"4\" value=\"$arr{homeroom}\">\n";
    print " $lex{'Blank=All'}, $lex{'Single Value Only'}</td></tr>\n";

    # Check Next Page
#    print "<tr><td class=\"ra\">$lex{'Check'} $lex{'Next Page'}</td>";
#    print qq{<td><input type="checkbox" name="chkrepcard" value="1"> $lex{'Report Card'}<br>
#		 <input type="checkbox" name="chkgradebook" value="1"> $lex{Gradebook}</td>\n};
#    print "<td></td></tr>\n";


    print "<tr><td></td><td><input type=\"submit\" value=\"$lex{Continue}\"></td></tr>\n";
    print "</table></form></body></html>\n";

    exit;

}
