#!/usr/bin/perl
#  Copyright 2001-2016 Leslie Richardson

#  This file is part of Open Admin for Schools.


# showStatus - called by iframe on main page. Show missing IRS, Duplicates, 
# Missing ASN, and Status Warnings and Advice.

use DBI;
use CGI;
use Time::JulianDay;


# only load DB codes
eval require "../etc/admin.conf.root";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = CGI->new;
print $q->header;

my $dbtype = 'mysql';
my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Missing Provincial Numbers
my $sth = $dbh->prepare("select count(*) from student where provnum = '' or provnum is NULL");
$sth->execute;
if ( $DBI::errstr ) { print DBI::errstr; die $DBI::errstr; }
my $provcount = $sth->fetchrow;

my $sth1 = $dbh->prepare("select lastname, firstname from studentall where provnum = ?");

# PSN Duplicates
my %provnumbers;
my $dupcount = 0;

my $sth = $dbh->prepare("select provnum, studnum from student
  where provnum is not NULL and provnum != '' order by treaty");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

my $dupnames;
while ( my ($provnum, $studnum) = $sth->fetchrow ) {
    if ( $provnumbers{$provnum} ) { 
	$dupcount++;
	
	# Get the Duplicate Names
	$sth1->execute($provnum);
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	while ( my ($lastname, $firstname) = $sth1->fetchrow ) {
	    $dupnames .= " $firstname $lastname ($provnum)/";
	}
    }
    $provnumbers{$provnum} = $studnum;
}



print qq{<!DOCTYPE html>\n};
print qq{<form action="/cgi-bin/sasked/qryschident.pl" method="post" style="display:inline;" target="_blank">\n};
print qq{<input type="submit" value="PSN Missing $provcount Dup $dupcount" };
print qq{title="PSN=Provincial Student Number };
if ( $dupcount ) { print qq{ Duplicates:$dupnames }; }
print qq{"></form>\n};

=head
print qq{<div><form action="/cgi-bin/pasi/statusstudent.pl" method="post" style="display:inline;" target="_blank">\n};
print qq{ <input type="submit" value="Status - Student:$statuscount{2}"></form>\n};
print qq{<form action="/cgi-bin/pasi/statusenrol.pl" method="post" style="display:inline;" target="_blank">\n};
print qq{ <input type="submit" value="Enrollment:$statuscount{4}"></form>\n};
print qq{</div>\n};
=cut

=head
# Sync Status (PCV values differ between cache and local records)
my $sth = $dbh->prepare("select count(*) from alberta_sync where ptype = ?");
$sth->execute(1);
if ( $DBI::errstr ) { print DBI::errstr; die $DBI::errstr; }
my $studenttotal = $sth->fetchrow;
if ( not $studenttotal ) { $studenttotal = 0; }

print qq{<div><form action="/cgi-bin/pasi/syncstudent.pl" method="post" style="display:inline;" target="_blank">\n};
print qq{<input type="submit" value="Sync - Student:$studenttotal "></form>\n};

$sth->execute(3);
if ( $DBI::errstr ) { print DBI::errstr; die $DBI::errstr; }
my $enroltotal = $sth->fetchrow;
print qq{<form action="/cgi-bin/pasi/syncenrol.pl" method="post" style="display:inline;" target="_blank">\n};
print qq{<input type="submit" value="Enrollment:$enroltotal "></form></div>\n};
=cut


# Missing IRS numbers (Indian Registry System)
my $sth = $dbh->prepare("select count(*) from student where treaty = '' or treaty is NULL");
$sth->execute;
if ( $DBI::errstr ) { print DBI::errstr; die $DBI::errstr; }
my $irscount = $sth->fetchrow;

my $sth1 = $dbh->prepare("select lastname, firstname from studentall where treaty = ?");


# IRS Duplicates
my %irsnumbers;
my $dupcount = 0;

my $sth = $dbh->prepare("select treaty, studnum from student
  where treaty is not NULL and treaty != '' order by treaty");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

my $dupnames;
while ( my ($irsnum, $studnum) = $sth->fetchrow ) {
    if ( $irsnumbers{$irsnum} ) { 
	$dupcount++;
	# Get the Duplicate Names
	$sth1->execute($irsnum);
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	while ( my ($lastname, $firstname) = $sth1->fetchrow ) {
	    $dupnames .= " $firstname $lastname ($irsnum)/";
	}
    }
    $irsnumbers{$irsnum} = $studnum;
}

print qq{<form action="/cgi-bin/eoy/resetselect.pl" method="post" style="display:inline;" target="_blank">\n};
print qq{<input type="hidden" value="1" name="page">\n};
print qq{<input type="hidden" value="treaty" name="field">\n};
print qq{<input type="hidden" name="inputtype" value="text">\n};
print qq{<input type="hidden" name="groupvalue" value="">\n};
print qq{<input type="hidden" name="studtable" value="current">\n};
print qq{<input type="hidden" name="grouptype" value="Grade">\n};
print qq{<input type="submit" value="IRS Missing $irscount  Dup $dupcount" };
print qq{title="IRS=Indian Registry System (Treaty Numbers) };
if ( $dupcount ) { print qq{ Duplicates:$dupnames }; }
print qq{"></form>\n};
