#!/usr/bin/perl
#  Copyright 2001-2018 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Error' => 'Error',
	   'Student' => 'Student',
	   'Continue' => 'Continue',
	   'No User Id' => 'No User Id',
	   'No Password' => 'No Password',
	   'Please Log In' => 'Please Log In',
	   'Grade' => 'Grade',
	   'Select' => 'Select',
	   'Grade' => 'Grade',
	   'Select' => 'Select',
	   'No Students Found' => 'No Students Found',
	   'Group' => 'Group',
	   'Attendance' => 'Attendance',
	   'Kit' => 'Kit',
	   'Lesson' => 'Lesson',
	   'Initial' => 'Initial',
	   'Progress' => 'Progress',
	   'Report' => 'Report',
	   'Pre-test' => 'Pre-test',
	   'Post-test' => 'Post-test',
	   'Data' => 'Data',
	   'Gain' => 'Gain',
	   'Loss' => 'Loss',
	   'Total Hours' => 'Total Hours',
	   'Percentage' => 'Percentage',
	   'Attendance' => 'Attendance',
	   'Name' => 'Name',
	   'Years' => 'Years',
	   'Date' => 'Date',
	   'Not Found' => 'Not Found',
	   'School' => 'School',

	   );

use DBI;
use CGI;
use CGI::Session;
use Number::Format qw(:all);
use Time::JulianDay;



my $self = 'lliRptProgressLocal.pl';


my $searchinterval = 30; # How many days forward or backwards to look for pre/post tests.


my $q = new CGI;
my %arr = $q->Vars;


my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $day = $tim[3];
if ( length( $month) == 1 ) { $month = '0'. $month; }
if ( length( $day) == 1 ) { $day = '0'. $day; }
my $currdate = "$year-$month-$day";
my $schyear = $year;
if ( $month < 7 ){ $schyear = $schyear - 1; }
my $prevyear = $schyear - 1;

my $currstartdate = "$schyear-08-01"; # Aug 1 of this school year
my $prevstartdate = "$prevyear-08-01"; # August 1 of prev year.



eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

eval require "../../lib/libreading.pl";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


print $q->header( -charset, $charset );


# Page Header
my $title = "LLI $lex{Progress} $lex{Report}";

print qq{$doctype\n<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="$css" type="text/css">\n};

print qq{<link rel="stylesheet" type="text/css" media="all" };
print qq{href="/js/calendar-blue.css" title="blue">\n};
print qq{<script type="text/javascript" src="/js/calendar.js"></script>\n};
print qq{<script type="text/javascript" src="/js/lang/calendar-en.js"></script>\n};
print qq{<script type="text/javascript" src="/js/calendar-setup.js"></script>\n};
print qq{<style type="text/css">div.head { font-weight:bold;font-size:90%; }</style>\n};

print qq{$chartype\n</head><body style="padding:1em 2em;">\n};
print qq{<p>[ <a href="$homepage">$lex{Main}</a> ]</p>\n};

print qq{<h1>$title</h1>\n};

if ( not $arr{page} ) {
    selectProgram();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    showReport();
} 


#----------------
sub selectProgram {
#----------------

    #foreach my $key ( sort keys %arr ) { print qq{K:$key V:$arr{$key}<br>\n};  }

    # Start Form
    print qq{<form action="$self" method="post">\n};
    print qq{<input type="hidden" name="page" value="1">\n};


    print qq{<div style="font-weight:bold;">$lex{Select} $lex{Group}</div>\n};
    print qq{<table cellpadding="5" cellspacing="0" border="1">\n};

    print qq{<tr><th>Name</th><th>Start Date</th><th>End Date</th><th>Description</th></tr>\n};
    print qq{<tr><td colspan="4"><input type="submit" value="$lex{Continue}"></td></tr>\n};

    # Select Program
    my $sth = $dbh->prepare("select * from lint_program order by startdate desc");

    my $sth1 = $dbh->prepare("select lastname, firstname from staff where userid = ?");
    my $sth2 = $dbh->prepare("select lastname, firstname from staff_transfer where userid = ?");


    
    $sth->execute;
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

    while ( my $ref = $sth->fetchrow_hashref ) {

	my %lr = %$ref;

	# Get Staff Member Name
	my $teachername;
	$sth1->execute( $lr{userid} );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	my ($ln,$fn ) = $sth1->fetchrow;
	if ( $ln ) {
	    $teachername = qq{<b>$ln</b>, $fn};
	} else {
	    
	    # Try the staff transfer table.
	    $sth2->execute( $lr{userid} );
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	    my ($ln,$fn ) = $sth2->fetchrow;
	    
	    if ( $ln ) {
		$teachername = qq{<b>$ln</b>, $fn};
	    } else {
		$teachername = qq{<span style="color:red;">$lex{'Not Found'}</span> $lr{userid}}
	    }
	}
	
	print qq{<tr><td><input type="radio" name="program" value="$ref->{id}">$teachername</td>\n};
	print qq{<td>$ref->{startdate}</td><td>$ref->{enddate}</td><td>$ref->{groupdesc}</td></tr>\n};
    
    }


    # Continue
    print qq{<tr><td colspan="4"><input type="submit" value="$lex{Continue}"></td></tr>\n};

    print qq{</table></form>\n};
    print qq{</body></html>\n};

    exit;

} # end of selectProgram



#---------------
sub showReport {
#---------------

    # foreach my $key ( sort keys %arr ) { print qq{K:$key V:$arr{$key}<br>\n}; }
    # only passed program id.

    my $fulltitle = "Primary, Intermediate &amp; Middle Years<br>Literacy Intervention";

    print qq{<h2>$fulltitle</h2>\n};


    # Get the Program Information
    my $sth = $dbh->prepare("select * from lint_program where id = ?");
    $sth->execute( $arr{program} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $progref = $sth->fetchrow_hashref;
    my %pr = %$progref;

    # Get JD of start/end of program and search dates, if required
    my $programstartjd = julian_day( split('-', $pr{startdate}) );
    my $prgstartPlus = join('-', inverse_julian_day( $programstartjd + $searchinterval ));
    my $prgstartMinus = join('-', inverse_julian_day( $programstartjd - $searchinterval ));

    my $programendjd = julian_day( split('-', $pr{enddate}) );
    my $prgendPlus = join('-', inverse_julian_day( $programendjd + $searchinterval ));
    my $prgendMinus = join('-', inverse_julian_day( $programendjd - $searchinterval ));

#    print qq{Program: prgstartPlus: $prgstartPlus Minus:$prgstartMinus<br>\n};
#    print qq{Program: End: $prgendPlus Minus:$prgendMinus<br>\n};


    # Get the LLI Instructor
    $sth = $dbh->prepare("select lastname, firstname from staff where userid = ?");
    $sth->execute( $pr{userid} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth->fetchrow;

    print qq{<div class="head">$firstname $lastname &ndash; $pr{groupdesc}</div>\n};
    print qq{<div class="head">}. formatDate($pr{startdate}). q{ &ndash; }. formatDate($pr{enddate}). qq{</div>\n};

    print qq{<div class="head">Search Interval +/- $searchinterval Days from Start/End of Program</div>\n};

    # Start Table and Headings.
    print qq{<table cellpadding="3" cellspacing="0" border="1" style="text-align:center;">\n};
    print qq{<tr><th>$lex{Name}</th><th>$lex{Grade}</th>\n};
    print qq{<th colspan="4">$lex{'Pre-test'} $lex{Data}</th>\n};
    print qq{<th>$lex{Initial} $lex{Kit}<br>/$lex{Lesson}</th>\n};
    print qq{<th colspan="4">$lex{'Post-test'} $lex{Data}</th>\n};
    print qq{<th>$lex{Gain}/$lex{Loss}<br>($lex{Years})</th><th>$lex{'Total Hours'}</th>\n};
    print qq{<th>$lex{Percentage}<br>$lex{Attendance}</th></tr>\n};

    print qq{<tr><th colspan="2"></th><th>$lex{Date}</th><th>DRA</th><th>Tot<br>Sc</th><th>Gr<br>Eq</th><th></th>\n};
    print qq{<th>$lex{Date}</th><th>DRA</th><th>Tot<br>Sc</th><th>Gr<br>Eq</th><th colspan="3"></th></tr>\n};


    # Get the students in program and names, studnum
    $sth = $dbh->prepare("select l.*,s.lastname,s.firstname, s.grade from lint_student l, studentall s
      where s.studnum = l.studnum and progid = ? order by s.lastname, s.firstname, l.id");

    # Get this test score and grade level
    my $sth2 = $dbh->prepare("select sum(score), count(*) from read_test_score 
      where testid = ?");

    my @students;
    my %comment;
    my %name;
    my $first = 1;


    $sth->execute( $arr{program} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    while ( my $ref = $sth->fetchrow_hashref ) {

	$first = 0;

	my %sr = %$ref; # sr = Student Record
	if ( $sr{comment} ) {
	    push @students, $sr{studnum};
	    $comment{$sr{studnum}} = $sr{comment};
	    $name{$sr{studnum}} = "<b>$sr{lastname}</b>, $sr{firstname}";
	}
	# foreach my $key ( sort keys %sr ) { print qq{SKey:$key V:$sr{$key}<br>\n}; } print qq{<br>\n};


	# Find the Pretest.
	my $sth1 = $dbh->prepare("select * from read_test where studnum = ? and
         to_days( tdate ) <= to_days('$pr{startdate}') and 
         to_days( tdate ) >= to_days('$prgstartMinus') order by tdate desc ");
	$sth1->execute( $sr{studnum} );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my $pretestref = $sth1->fetchrow_hashref;


	if ( not $pretestref ) { # move the date to look at first test WITHIN date range
	    my $sth1 = $dbh->prepare("select * from read_test where studnum = ? and
             to_days( tdate ) > to_days('$pr{startdate}') and  to_days( tdate ) <= to_days('$prgstartPlus')
             order by tdate "); # first one within this date range.
	    $sth1->execute( $sr{studnum} );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    $pretestref = $sth1->fetchrow_hashref;
	}


	my %pretest = %$pretestref;

#	 foreach my $key ( sort keys %pretest ) { print qq{K:$key V:$pretest{$key}<br>\n}; }	

	# Get the pretest Scores
	$sth2->execute( $pretest{id} );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my ( $prescoretotal, $prescorecount ) = $sth2->fetchrow;
	my $prepossibletotal = $prescorecount * 4;

	my $equivgrade = scoreToGrade( $prescoretotal, $pretest{readlevel} );
#	print qq{STUD:$sr{studnum} Pre:$prescoretotal RL:$pretest{readlevel} EGr:$equivgrade<br>\n};
	my $equivYM = yearToYearMonth( $equivgrade );

	
	# Start of Line
	print qq{<tr><td class="la"><b>$sr{lastname}</b>, $sr{firstname} };
	if ( $sr{startdate} ) { print qq{<br><span style="font-size:80%;"><b>Late Entry</b> $sr{startdate}</span>}; }
	print qq{</td><td>$sr{grade}</td>\n};
	print qq{<td>$pretest{tdate}</td>};
	print qq{<td>$pretest{readlevel}</td>};
	if ( $pretest{readlevel} < 40 ) {
	    print qq{<td>$prescoretotal</td>\n};
	} else {
	    print qq{<td>$prescoretotal / $prepossibletotal</td>\n};
	}
	print qq{<td>$equivYM</td>\n};


	# Now the Kit info
	print qq{<td>$sr{initialkit} / $sr{initiallesson}</td>\n};

	if ( $sr{dropped} ) { # dropped course
	    print qq{<td>$sr{enddate}</td><td colspan="3"><b>Dropped</b></td>};
	    print qq{<td></td><td></td><td></td></tr>\n};

	} else {

	    # Find the Posttest.
	    $sth1 = $dbh->prepare("select * from read_test where studnum = ? and
              to_days( tdate ) >= to_days('$pr{enddate}') and 
              to_days( tdate ) <= to_days( '$prgendPlus' )");
	    $sth1->execute( $sr{studnum} );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    my $posttest_ref = $sth1->fetchrow_hashref;
#	    print qq{Post Test ref: $posttest_ref<br>\n};

	    if ( not $posttest_ref ) { # move the date to look at first test WITHIN date range
		$sth1 = $dbh->prepare("select * from read_test where studnum = ? and
                  to_days( tdate ) <= to_days( '$pr{enddate}' ) and 
                  to_days( tdate ) >= to_days( '$prgendMinus' ) order by tdate desc");
		$sth1->execute( $sr{studnum} );
		if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
		$posttest_ref = $sth1->fetchrow_hashref;
		if ( $posttest_ref and $posttest_ref->{id} == $pretestref->{id} ) { # same test; bad!
		    $posttest_ref = undef;
		}
	    }

#	    print qq{Post Test 2 ref: $posttest_ref<br>\n};

	    my %posttest = %$posttest_ref;

#	    print qq{Post: ", %posttest, qq{<br>\n};


#	print qq{<div>Post Test</div>\n};
#	foreach my $key ( sort keys %posttest ) { print qq{K:$key V:$posttest{$key}<br>\n}; }	

	    # Get the posttest Scores
	    $sth2->execute( $posttest{id} );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    my ( $postscoretotal, $postscorecount ) = $sth2->fetchrow;
	    my $postpossibletotal = $postscorecount * 4;

	    my $postequivgrade = scoreToGrade( $postscoretotal, $posttest{readlevel} );
	    my $postequivYM = yearToYearMonth( $postequivgrade );
	    

	    print qq{<td>$posttest{tdate}</td>\n};
	    print qq{<td>$posttest{readlevel}</td>\n};
	    if ( $posttest{readlevel} < 40 ) {
		print qq{<td>$postscoretotal</td>\n};
	    } else {
		print qq{<td>$postscoretotal / $postpossibletotal</td>\n};
	    }
	    print qq{<td>$postequivYM</td>\n};

	    # Loss/Gain.
	    my ($delta, $deltaYM);
	    if ( $postequivgrade ) {
		$delta = format_number( $postequivgrade - $equivgrade, 2,2);
		$deltaYM = yearToYearMonth( $delta );
	    }
	    print qq{<td>$deltaYM</td>};

	    # Hours Taught / Percent Attendance. 
	    # Hours taught is entered by teacher, attendance is calculated.
	    print qq{<td>$sr{programhours}</td>};

	    # Attendance
	    my ($attendance, $enrolledhours);
	    if ( not $pr{programhours} ) { 
		print qq{<h3>$lex{Error}: Program Hours not defined</h3>\n};
		print qq{</body></html>\n};
		exit;
		
	    } else { # OK, $pr{programhours} has a non zero value.

		if ( $sr{attendance} ) { # late start student; attendance field holds hours enrolled
		    $enrolledhours = $sr{attendance};
		} else { 
		    $enrolledhours = $pr{programhours};
		}

		$attendance = format_number( ( $sr{programhours} / $enrolledhours ) * 100, 0);
	    }

#	    print "SR ATT:$sr{attendance} HOURS:$sr{programhours}  PRG:$pr{programhours}<br>\n";
	    
	    print qq{<td>( $sr{programhours} / $enrolledhours ) $attendance%</td></tr>\n};

	} # end of else: (ie. not dropped)

    } # end of student loop.

    if ( $first ) {
	print qq{</table></form><h1>$lex{'No Students Found'}</h1>\n};
	print qq{</body></html>\n};
	exit;
    }

    print qq{</table>};


    # Comments section.
    my $first = 1;
    foreach my $studnum ( @students ) { 
	if ( $first ) {
	    print qq{<h3>Comments</h3>\n};
	    print qq{<table cellpadding="3" cellspacing="0" border="1">\n};
	    $first = 0;
	}

	print qq{<tr><td style="la">$name{$studnum}</td><td class="la">$comment{$studnum}</td></tr>\n}
    }

    if ( not $first ) { # close table.
	print qq{</table>\n};
    }


    print qq{</body></html>\n};

    exit;

} # end of mkHTMLReport



#-------------
sub formatDate {
#-------------

    my ( $year, $mon, $day ) = split /-/, shift;
    return "$year-$s_month[$mon]-$day";
}
