#!/usr/bin/perl
#  Copyright 2001-2012 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Reports' => 'Reports',
	   'Gradebook' => 'Gradebook',
	   'Main' => 'Main',
	   'Student' => 'Student',
	   'Report' => 'Report',
	   'Subject' => 'Subject',
	   'Blank Mark Sheets' => 'Blank Mark Sheets',
	   'Password' => 'Password',
	   'Please Log In' => 'Please Log In',
	   'by Subject' => 'by Subject',
	   'Error' => 'Error',

	   );

use DBI;
use CGI::Session;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " : $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;
my $q = CGI->new;

# Get Session Information...
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

my $logged_in = $session->param('logged_in');
my $userid = $session->param('userid');

print $q->header( -charset, $charset );

my $title = "$lex{Gradebook} $lex{Reports}";
print "$doctype\n<html><head><title>$title</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
$chartype\n</head><body style=\"padding:1em 2em;\">\n";

print "[ <a href=\"$tchpage\">$lex{Main}</a> |\n";
print "<a href=\"gbmain.pl\">$lex{Gradebook}</a> ]\n";

print "<h1>$title</h1>\n";


if ( not $logged_in ){
    print $lex{'Please Log In'};
    print "</body></html>\n";
    exit;
}
# Ok, we have a login. Values below we have in environment.


# Print Reports Line

print qq{<p><form action="rptmarksheet.pl" method="post">\n};
print qq{<input type="submit" value="$lex{'Blank Mark Sheets'}"></form></p>\n};

print qq{<p><form action="rptsubj.pl" method="post">\n};
print qq{<input type="submit" value="$lex{Subject} $lex{Report}"></form></p>\n};

print qq{<p><form action="rptstud.pl" method="post">\n};
print qq{<input type="submit" value="$lex{Student} $lex{Report}"></form></p>\n};

print qq{<p><form action="rptstudpwd.pl" method="post">\n};
print qq{<input type="submit" value="$lex{Password} $lex{Report}"></form></p>\n};

print "</body></html>\n";
