#!/usr/bin/perl
#  Copyright 2001-2018 Leslie Richardson

#  This file is part of Open Admin for Schools.


my %lex = ('Student Report' => 'Student Report',
	   'Responsibility' => 'Responsibility',
	   'Strategies, Resources, Activities' => 'Strategies, Resources, Activities',
	   'Objectives' => 'Objectives',
	   'Student' => 'Student',
	   'Student Team' => 'Student Team',
	   'Name' => 'Name',
	   'Position' => 'Position',
	   'Assessments' => 'Assessments',
	   'Dates' => 'Dates',
	   'Category' => 'Category',
	   'Comments' => 'Comments',
	   'Back to Special Needs Students' => 'Back to Special Needs Students',
	   'Student IEP' => 'Student IEP',
	   'Identification' => 'Identification',
	   'Name' => 'Name',
	   'Gender' => 'Gender',
	   'Birthdate' => 'Birthdate',
	   'Grade' => 'Grade',
	   'Designation Date' => 'Designation Date',
	   'DDPF Level' => 'DDPF Level',
	   'Designation' => 'Designation',
	   'Medical(other)' => 'Medical(other)',
	   'School' => 'School',
	   'Parent/Guardian' => 'Parent/Guardian',
	   'Address' => 'Address',
	   'Home Phone' => 'Home Phone',
	   'Emergency Contact' => 'Emergency Contact',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;
use Cwd;


# Set prepath for config file: (/tcgi or cgi/schedule)
my $prepath = '../..';
if ( getcwd() =~ /tcgi/){ # we are in tcgi
    $prepath = '..';
}

# Read config variables
eval require "$prepath/etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

if ( getcwd() =~ /tcgi/){ # we are in tcgi
    $css = $tchcss;
    $homepage = $tchpage;
}


my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

#foreach my $key ( sort keys %arr ) {
#    print qq{K:$key VAL:$arr{$key}<br>\n};
#}


# These MUST be passed in order to find student.
my $studnum = $arr{studnum};
my $database = $arr{school};
#my $schoolname = $dbase{$database}; # from global.conf dbase hash.

# print "Studnum:$studnum<br>\n";

# Print Page Header
my $title = $lex{'Student IEP'};

print qq{$doctype\n<html><head><title>$title</title>\n};
print qq{<link rel="stylesheet" href="$css" type="text/css">$chartype\n};
print qq{</head><body>\n};


my $dsn = "DBI:mysql:$database";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

# Load Student Info from the local school database.
my $sth = $dbh->prepare("select * from student where studnum = ?");
$sth->execute( $studnum );
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }  
my $sref = $sth->fetchrow_hashref;
# my %sr = %$sref;

# Set Current Date
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
$wday++;
$currdate = "$dow[$wday], $month[$mon] $mday, $year";


eval require "$iepdir/cgi/ppp.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}
# Loads userid, password, dbase for IEP db.


# Now get handle to IEP database.
my $dsn = "DBI:mysql:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;


# Look for student
my %sp;
print "Studnum:$studnum<br>\n";
my $sth = $dbh->prepare("select * from special where studnum = ?");
$sth->execute( $studnum );
if ($DBI::errstr) { print "Error: $DBI::errstr"; die $DBI::errstr; }
my $spref = $sth->fetchrow_hashref;
%sp = %$spref; 

foreach my $key ( sort keys %sp ) {
    print qq{K:$key Val:$sp{$key}<br>\n};
}


$studname = "$sp{firstname} $sp{lastname}";
$shortschool = $database;


# Print the heading section 
print qq{<table width="100%"><tr><td colspan="2">};

print qq{[ <a href="specedview.pl">$lex{'Back to Special Needs Students'}</a> ]</td></tr>\n};
print qq{<tr><td><h1>$title</h1></td>\n};
print qq{<td class="ra">$currdate</td></tr></table>\n};

print qq{<div style="font-size:140%;font-weight:bold;margin:1em;">$studname</div>\n};

print qq{<h2>$lex{Identification}</h2>\n};
print qq{<table cellspacing="0" cellpadding="3" border="0">\n};

print qq{<tr><td class="bra">$lex{Name}</td><td>$studname </td></tr>\n};
print qq{<tr><td class="bra">$lex{Gender}</td><td>$sp{sex}</td></tr>\n};
print qq{<tr><td class="bra">$lex{Birthdate}</td><td>$sp{birthdate}</td></tr>\n};
print qq{<tr><td class="bra">$lex{Grade}</td><td>$sp{grade}</td></tr>\n};


print qq{<tr><td class="bra">$lex{Designation}</b></td><td> $sp{designation}</td></tr>\n};

print qq{<tr><td class="bra">$lex{'Medical(other)'}</td><td> $sp{medical}</td></tr>\n};
print qq{<tr><td class="bra">$lex{School}</td><td class="la">$schoolname</td></tr>\n};
print qq{<tr><td class="bra">$lex{'Parent/Guardian'}</td><td>$sr{par1_firstname} $sr{par1_lastname}</td></tr>\n};

print qq{<tr><td class="bra">$lex{Address}</td></td><td>$sr{address1} $sr{city1} $sr{prov1}</td></tr>\n};
print qq{<tr><td class="bra">$lex{'Home Phone'}</td><td>$sr{hphone1}</td></tr>\n};

print qq{<tr><td class="bra">$lex{'Emergency Contact'}</td>};
print qq{<td>$sr{emname} - H:$sr{emhphone} W:$sr{emwphone} C:$sr{emcell}</td></tr>\n};
print qq{</table>\n};



# Now lets do the team.
$sth1 = $dbh->prepare("select * from team where studnum = ?");
$sth1->execute( $studnum );
if ($DBI::errstr) { print $DBI::errstr; die;}

print qq{<h2>$lex{'Student Team'}</h2>\n};
print qq{<table cellspacing="0" cellpadding="4" border="1" style="margin:1em;">\n};
print qq{<tr><th>$lex{Name}</th><th>$lex{Position}</th></tr>\n};


while ( my $tref = $sth1->fetchrow_hashref ) {
    print "HERE!<br>\n";
    print "Team", %t, "<br>\n";
    my %t = %$tref;
#    my ($teammember,$dud) = split /\(/,$team[2];
    #push @teamarray,$teammember;  # needed for signature page
    print qq{<tr><td>$t{userid}</td><td>$team[3]</td></tr>\n};
}
print qq{</table>\n};


# Now let's do the goals
$sth = $dbh->prepare("select * from evalmst where studnum = ?");
$sth->execute( $studnum );
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

print  qq{<h2>$lex{Student} $lex{Objectives}</h2>\n};


# Subjects Loop; once for each subject.
while ( my $ref = $sth->fetchrow_hashref ) {
    my %evalmst = %$ref;
    my $subnum = $evalmst{subnum};

    #lookup subject name
    my $sth1 = $dbh->prepare("select description from subject where catnum = ?");
    $sth1->execute( $subnum );
    if ($DBI::errstr) { print $DBI::errstr; die;}
    my $subname = $sth1->fetchrow; 


    print qq{<table cellspacing="0" cellpadding="4" border="1" style="margin:1em;">\n};
    print qq{<tr><th colspan="2">$subname ($subnum)</th></tr>\n};

    print qq{<tr><td class="bra">$lex{'Strategies, Resources, Activities'}</td><td>$evalmst{strategy}</td></tr>\n};        print qq{<tr><td class="bra">$lex{Responsibility}</td><td>$evalmst{responsible}</td></tr>\n};

    print qq{<tr><td class="bra">Long Term Objective</td><td>$evalmst{longtermobjective}</td></tr>\n};
    print qq{<tr><td class="bra">Target Skill</td><td>$evalmst{targetskill}</td></tr>\n};
    print qq{<tr><td class="bra">Performance Level</td><td>$evalmst{currperform}</td></tr>\n};
    print qq{<tr><td class="bra">Evaluation Method</td><td>$evalmst{evalmethod}</td></tr>\n};
    
    print qq{<tr><td class="la" colspan="2">};

    # Now print the objectives
    print qq{<b>$lex{Objectives}</b><ul>\n};
    for my $idx (1..32) {
	my $key = "obj$idx";
	if ( $evalmst{$key} ){
	    print qq{<li>$evalmst{$key}</li>\n};
	}
    }
    print qq{</ul></td></tr></table>\n\n};

} # End of Subject "For" Loop

print qq{</body></html>\n};
