#!/usr/bin/perl
#  Copyright 2001-2014 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Delete Attendance' => 'Delete Attendance',
	   'Date' => 'Date',
	   'Reason' => 'Reason',
	   'Period' => 'Period',
	   'Student' => 'Student',
	   'Are you sure' => 'Are you sure',
	   'Main' => 'Main',
	   'Delete the Record' => 'Delete the Record',
	   'Subject' => 'Subject',
	   'Section' => 'Section',
	   'Attendance Records' => 'Attendance Records',
	   'Edit' => 'Edit',
	   'Contact' => 'Contact',
	   'Record Deleted' => 'Record Deleted',
	   'Period' => 'Period',
	   'Please Log In' => 'Please Log In',
	   'Error' => 'Error',
	   'Yes' => 'Yes',
	   'Delete' => 'Delete',

	   );

my $self = 'tattdel.pl';


use CGI;
use CGI::Session;
use DBI;

my $q = new CGI;
my %arr = $q->Vars;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;


# Setup Session
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

# Get Session Values (a defined userid means it was passed)
if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header( -charset, $charset );
    print qq{[ <a href="$tchpage\">$lex{Main}</a> ]\n};
    print "<h1>$lex{'Please Log In'}</h1>\n";
    print "</body></html>\n";
    exit;
}
# Ok, we have a login. Values below we have in environment.

my $userid = $session->param('userid');
my $duration = $session->param('duration');
$session->expire('logged_in',$duration); # duration is already in +20m format;

print $session->header( -charset, $charset );

my $title = $lex{'Delete Attendance'};
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";
print qq{$chartype\n</head><body style="padding:1em;">[ <a href=\"$tchpage\">$lex{Main}</a> ]\n};

print qq{<h1>$title</h1>\n};

if ( $arr{deleteflag} ) {
    delete $arr{deleteflag};
    deleteRecord();
}


$sth = $dbh->prepare("select * from attend where attid = ?"); 
$sth->execute($arr{id});
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my @arr = $sth->fetchrow;

$sth1 = $dbh->prepare("select firstname, lastname from studentall where studnum = ?"); 
$sth1->execute( $arr[1] );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ($firstname, $lastname) = $sth1->fetchrow;

my $description;
if ( $arr[5] ) { # find a description
    $sth2 = $dbh->prepare("select description from subject where subjsec = ?"); 
    $sth2->execute( $arr[5] );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    $description = $sth2->fetchrow;
}


print "<table><tr><td class=\"bra\">$lex{Student}</td>\n";
print "<td class=\"la\">$firstname $lastname ($arr[1])</td></tr>\n";

print "<tr><td class=\"bra\">$lex{Date}</td><td>$arr[2]</td></tr>\n";

print "<tr><td class=\"bra\">$lex{Reason}</td><td>$arr[3]</td></tr>\n";

print "<tr><td class=\"bra\">$lex{Period}</td><td>$arr[4]</td></tr>\n";

if ( $arr[5] ) { # if we have a subject, show it...
    print "<tr><td class=\"bra\">$lex{Subject} -$lex{Section}";
    print ":</td><td>$description ($arr[5])</td></tr>\n";
}

print "</table>\n";

print "<p><em>$lex{Delete}: $lex{'Are you sure'}?</em></p>\n";

print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"id\" value=\"$arr{id}\">
<input type=\"hidden\" name=\"deleteflag\" value=\"1\">
<input type=\"submit\" value=\"$lex{Yes}, $lex{'Delete the Record'}\">
</form></body></html>\n";



#---------------
sub deleteRecord {
#---------------

    # foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }
    
    # Get student number, date, and period
    $sth = $dbh->prepare("select studentid, absdate, period from attend where attid = ?");
    $sth->execute( $arr{id} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ($studnum, $date, $period) = $sth->fetchrow;

    # Get Name
    $sth = $dbh->prepare("select firstname, lastname from studentall where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ($firstname, $lastname) = $sth->fetchrow;


    $sth = $dbh->prepare("delete from attend where attid = ?");
    $sth->execute( $arr{id} );

    if ( not $DBI::errstr ) {
	print "<h3>$lex{'Record Deleted'}</h3>\n";

    } else {
	print "<h3>$lex{Error}: $DBI::errstr<br>\n";
	print "$lex{Contact}: $adminname <a href=\"mailto:$adminemail\">$adminemail</a></h3>\n";
    }


    print "<table><tr><td class=\"bra\">$lex{Student}</td>\n";
    print "<td class=\"la\">$firstname $lastname</td></tr>\n";
    print "<tr><td class=\"bra\">$lex{Date}</td><td>$date</td></tr>\n";
    print "<tr><td class=\"bra\">$lex{Period}</td><td>$period</td></tr>\n";
    print "</table>\n";


    print "<p>[ <a href=\"tattdeled.pl\">$lex{Edit} $lex{'Attendance Records'}</a> |\n";
    print " <a href=\"$tchpage\">$lex{Main}</a> ]</p></body></html>\n";

    exit;

}
