#!/usr/bin/perl

# A program to update school databases using a passed SQL file of commands.
# It creates full backups first.

use Cwd;

my $backupDir = '/opt/openadmin/backup';
my $mysqlexec = '/usr/bin/mysql';
my $mysqldumpexec = '/usr/bin/mysqldump';

my $cwd = getcwd();

$schooldb[0] = "chiefnapew";
$schooldb[1] = "chieftaylor";
$schooldb[2] = "eagleview";
$schooldb[3] = "littlepine";
$schooldb[4] = "mosquito";
$schooldb[5] = "pewasenakwan";
$schooldb[6] = "poundmaker";
$schooldb[7] = "robincameron";
$schooldb[8] = "thunderchild";
$schooldb[9] = "willowcree";
$schooldb[10] = "khwc";

$schooldb[11] = "atak";
$schooldb[12] = "cws";
$schooldb[13] = "moosomin";
$schooldb[14] = "saulteaux";
$schooldb[15] = "sweetgrass";

$schooldb[16] = "cpec";
$schooldb[17] = "mec";
$schooldb[18] = "noec";
$schooldb[19] = "payepot";
$schooldb[20] = "pps";
$schooldb[21] = "tns";
$schooldb[22] = "fhdemo";


# ======== No need to change anything below here unless you just 'gotta ====

if (not @ARGV) {
    die "\nUsage: dbupdate  filename \n\n";
}

my $filename = "$cwd/$ARGV[0]";

# Setup Dates
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
if ( length($month) == 1 ) { $month = '0'. $month; }
my $day = @tim[3];
if ( length($day) == 1 ) { $day = '0'. $day; }
my $currdate = "$year-$month-$day";
my $currfiledate = "$year$month$day";

print "\nEnter MySQL Root Password: ";
my $mysqlroot = <STDIN>;
chomp $mysqlroot;


foreach $dbase ( @schooldb ){

    # Check for existing backup file.
    my ($counter, $backupfile, $backupError );
    do {
	$counter++;
	if ( $counter > 20 ) { $backupError = 1; }
	$backupfile = "$dbase-$currfiledate-$counter.sql"
    } until not -e "$backupDir/$backupfile" or $backupError;

    if ( $backupError ) {
	print "Backup File not created.\n";
	exit;
    }
    print "Backup file check complete: $backupDir/$backupfile\n";

    my $error = system("$mysqldumpexec -p$mysqlroot -u root $dbase > $backupDir/$backupfile");
    if ( not $error ) {
	print "MySQL Database Backup Created: $dbase\n\n";
    } else {
	print "Backup Error: File:$backupfile $error: $!\n";
	exit;
    }


    my $error = system("$mysqlexec -p$mysqlroot -u root $dbase < $filename");
    if ( not $error ) {
	print "SQL File parsed: $dbase\n\n";
    } else {
	print "SQL File Error:$filename - $error: $!\n";
	exit;
    }

}
