#!/usr/bin/perl

use DBI;
use CGI;

# Munge attendance records for date range below for gr 7-9 students 
#  down from 7 or so per day to 2 per day.

$startdate = '2010-09-01';
$enddate = '2010-10-29';

# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
%arr = $q->Vars;

$dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

# Page Head Section.
print "$doctype\n<html><head><title>Attendance Fix</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print "<h1>Attendance Fix</h1>\n";


# Get Students.
my $sth1 = $dbh->prepare("select grade from studentall where studnum = ?");

my @students = ();
my $sth = $dbh->prepare("select distinct studentid from attend
  where to_days(absdate) >= to_days('$startdate') and
  to_days(absdate) <= to_days('$enddate') and studentid != ''");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die;}
while ( my ( $studnum ) = $sth->fetchrow ) {

    # check grade
    $sth1->execute( $studnum );
    if ($DBI::errstr){ print $DBI::errstr; die;}
    my $grade = $sth1->fetchrow;

    # print "Stud:$studnum  Grade:$grade<br>\n";

    if ( $grade == 7 or $grade == 8 or $grade == 9 ) {
	#$students{$studnum} = 1;
	push @students, $studnum;
    }
}
# we now have the students to work with 


# Now loop through all distinct dates.
$sth = $dbh->prepare("select distinct absdate from attend
  where to_days(absdate) >= to_days('$startdate') and
  to_days(absdate) <= to_days('$enddate') and studentid = ?");

#$sth1 = $dbh->prepare("select attid, reason, period from attend
#  where studentid = ? and absdate = ? order by period");

$sth1 = $dbh->prepare("select * from attend  where studentid = ? and absdate = ? order by period");


foreach my $studnum ( @students ) {

    $sth->execute( $studnum );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}

    while ( my $absdate = $sth->fetchrow ) {

	$sth1->execute( $studnum, $absdate );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	my $ref = $sth1->fetchall_arrayref;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}

	updaterecords( $ref );

    }

}


#----------------
sub updaterecords {
#----------------

    my $ref = shift;
    my @recs = @$ref;

    # prepare sql.
    my $sth = $dbh->prepare("insert into attend (studentid, absdate, reason, period )
     values( ?, ?, ?, ? )");

    my $sth1 = $dbh->prepare("delete from attend where attid = ?");

    my ( $amlate, $pmlate, $amabs, $pmabs);
    my $first = 1;
    my ($studnum, $absdate );
    my @delete = ();

    foreach my $val ( @recs ) {
	my @attrec = @$val;
	if ( $first ) {
	    $studnum = $attrec[1];
	    $absdate = $attrec[2];
	    $first = 0;
	}

	push @delete, $attrec[0]; # record to delete.


	if ( $attrec[4] > 4 ) { # afternoon;
	    if ( $attrec[3] =~ m/Absent/ ) { #absent
		$pmabs++;
	    } else {
		$pmlate++;
	    }
	} else {
	    if ( $attrec[3] =~ m/Absent/ ) { #absent
		$amabs++;
	    } else {
		$amlate++;
	    }
	}
    }

   print "Stud: $studnum - Date:$absdate - AM:$amabs:$amlate  - PM:$pmabs:$pmlate ";

    # Insert AM Records (if any)
    if ( $amabs > 1 ) { # write absent.
#	$sth->execute( $studnum, $absdate, 'Absent Unexcused', 1 );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	print "AM ABS ";

    } elsif ( $amlate > 1 ) { # write a late
#	$sth->execute( $studnum, $absdate, 'Late Unexcused', 1 );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	print "AM Late ";
    }

    # Insert PM Records (if any)
    if ( $pmabs > 1 ) { # write absent.
#	$sth->execute( $studnum, $absdate, 'Absent Unexcused', 2 );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	print "PM Abs ";

    } elsif ( $pmlate > 1 ) { # write a late
#	$sth->execute( $studnum, $absdate, 'Late Unexcused', 2 );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	print "PM Late ";
    }
    print "\n";

    # Delete current records.
    foreach my $id ( @delete ) {
#	$sth1->execute( $id );
	print "DEL:$id ";
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
    }
    print "\n";


    print "Stud: $studnum - Date:$absdate - AM:$amabs:$amlate  - PM:$pmabs:$pmlate\n";

}
